Index: blocks/tags/block_tags.php
===================================================================
RCS file: /cvsroot/moodle/moodle/blocks/tags/block_tags.php,v
retrieving revision 1.14
diff -u -r1.14 block_tags.php
--- blocks/tags/block_tags.php	5 Jan 2009 21:37:22 -0000	1.14
+++ blocks/tags/block_tags.php	5 Mar 2009 14:56:13 -0000
@@ -226,42 +226,42 @@
                 // only show the input form on course pages for those allowed (or not barred)
                 if ($coursepage && $canedit) {
                     //$this->content->footer .= coursetag_get_jscript();
-                    $tagthisunit = get_string('tagthisunit', $tagslang);
                     $buttonadd = get_string('add', $tagslang);
                     $arrowtitle = get_string('arrowtitle', $tagslang);
                     $coursetaghelpbutton = helpbutton('addtags', 'adding tags', $tagslang, TRUE, FALSE, '', TRUE);
+                    $edit_tags = get_string('edittags', $tagslang);
                     $sesskey = sesskey();
                     $this->content->footer .= <<<EOT
-                        <hr />
-                        <form action="{$CFG->wwwroot}/tag/coursetags_add.php" method="post" id="coursetag"
-                                onsubmit="return ctags_checkinput(this.coursetag_new_tag.value)">
-                            <div style="display: none;">
-                                <input type="hidden" name="entryid" value="$COURSE->id" />
-                                <input type="hidden" name="userid" value="$USER->id" />
-                                <input type="hidden" name="sesskey" value="$sesskey" />
-                            </div>
-                            <div><label for="coursetag_new_tag">$tagthisunit</label></div>
-                            <div class="coursetag_form_wrapper">
-                            <div class="coursetag_form_positioner">
-                                <div class="coursetag_form_input1">
-                                    <input type="text" name="coursetag_sug_keyword" class="coursetag_form_input1a" disabled="disabled" />
-                                </div>
-                                <div class="coursetag_form_input2">
-                                    <input type="text" name="coursetag_new_tag" id="coursetag_new_tag" class="coursetag_form_input2a"
-                                        onfocus="ctags_getKeywords()" onkeyup="ctags_getKeywords()" maxlength="50" />
-                                </div>
-                                <div class="coursetag_form_input3" id="coursetag_sug_btn">
-                                    <a title="$arrowtitle">
-                                        <img src="$CFG->pixpath/t/arrow_left.gif" width="10" height="10" alt="enter" onclick="ctags_setKeywords()" />
-                                    </a>
-                                </div>
-                            </div>
-                            <div style="display: inline;">
-                                <button type="submit">$buttonadd</button>
-                                $coursetaghelpbutton
-                            </div>
-                            </div>
-                        </form>
+<hr />
+<form action="{$CFG->wwwroot}/tag/coursetags_add.php" method="post" id="coursetag"
+        onsubmit="return ctags_checkinput(this.coursetag_new_tag.value)">
+    <div style="display: none;">
+        <input type="hidden" name="entryid" value="$COURSE->id" />
+        <input type="hidden" name="userid" value="$USER->id" />
+        <input type="hidden" name="sesskey" value="$sesskey" />
+    </div>
+    <div class="coursetag_form_wrapper">
+        <div class="coursetag_form_positioner">
+            <div class="coursetag_form_input1">
+                <input type="text" name="coursetag_sug_keyword" class="coursetag_form_input1a" disabled="disabled" />
+            </div>
+            <div class="coursetag_form_input2">
+                <input type="text" name="coursetag_new_tag" id="coursetag_new_tag" class="coursetag_form_input2a"
+                    onfocus="ctags_getKeywords()" onkeyup="ctags_getKeywords()" maxlength="50" />
+            </div>
+            <div class="coursetag_form_input3" id="coursetag_sug_btn">
+                <a title="$arrowtitle">
+                    <img src="$CFG->pixpath/t/arrow_left.gif" width="10" height="10" alt="enter" onclick="ctags_setKeywords()" />
+                </a>
+            </div>
+        </div>
+        <div style="display: inline;">
+            <button type="submit">$buttonadd</button>
+            $coursetaghelpbutton
+            <a href="$CFG->wwwroot/tag/coursetags_edit.php?courseid=$COURSE->id" title="$edit_tags">$edit_tags</a>
+        </div>
+    </div>
+</form>
 EOT;
                     // add the edit link
                     $this->content->footer .= '
@@ -271,34 +271,6 @@
                         </div>';
                 }
 
-                // Navigation elements at the bottom of the block
-                // show the alternative displays options if available
-                if ($mytags or $officialtags or $commtags or $coursetags) {
-                    $this->content->footer .= '<div id="coursetagslinks"></div>';
-                }
-                // This section sets the order of the links
-                $coursetagslinks = array();
-                if ($mytags) {
-                    $coursetagslinks['my'] = array('title'=>get_string('mytags2', $tagslang),
-                                                    'onclick'=>'f_mytags',
-                                                    'text'=>get_string('mytags1', $tagslang));
-                }
-                // because alltags is always present, only show link if there is something else as well
-                if ($alltags and ($mytags or $officialtags or $commtags or $coursetags)) {
-                    $coursetagslinks['all'] = array('title'=>get_string('alltags2', $tagslang),
-                                                    'onclick'=>'f_alltags',
-                                                    'text'=>get_string('alltags1', $tagslang));
-                }
-                if ($officialtags) {
-                    $coursetagslinks['off'] = array('title'=>get_string('officialtags2', $tagslang),
-                                                    'onclick'=>'f_officialtags',
-                                                    'text'=>get_string('officialtags1', $tagslang));
-                }
-                //if ($commtags) {
-                //    $coursetagslinks['com'] = array('title'=>get_string('communitytags2', $tagslang),
-                //                                    'onclick'=>'f_commtags',
-                //                                    'text'=>get_string('communitytags1', $tagslang));
-                //}
                 if ($coursetags) {
                     $coursetagslinks['crs'] = array('title'=>get_string('coursetags2', $tagslang),
                                                     'onclick'=>'f_coursetags',